// Output generated from file: D:/fractal/Fragmentarium/Output/Mandelbulb/accidents2/37-13_Files/37-13.frag
// Created: Sat Jan 21 13:40:20 2017
// Output generated from file: D:/fractal/Fragmentarium/Output/Mandelbulb/accidents2/37-5_Files/37-5.frag
// Created: Sat Jan 21 12:04:03 2017
// Output generated from file: D:/fractal/Fragmentarium/Output/Mandelbulb/accidents2/37-4_Files/37-4.frag
// Created: Sat Jan 21 00:04:32 2017
// Output generated from file: D:/fractal/Fragmentarium/FragDick/Examples/Historical 3D Fractals/Mandelbulb.frag
// Created: Fri Jan 20 22:12:06 2017
#info Mandelbulb Distance Estimator
#define providesInit
#define USE_IQ_CLOUDS
#define KN_VOLUMETRIC
#define USE_EIFFIE_SHADOW
#define MULTI_SAMPLE_AO
#define AUTOFOCUS
#include "MathUtils.frag"
#include "DE-kn2cr11.frag"
//#include "DE-Raytracer.frag"
//#include "MathUtils.frag"


#group ReciprocalXYZ3b
uniform bool reciprocalX3b;  checkbox[false]
uniform bool reciprocalX3bVar1;  checkbox[false]
uniform bool reciprocalY3b;  checkbox[false]
uniform bool reciprocalY3bVar1;  checkbox[false]
uniform bool reciprocalZ3b;  checkbox[false]
uniform bool reciprocalZ3bVar1;  checkbox[false]
uniform float Limiter1; slider[-2,0.67,2]
uniform float Limiter2; slider[-2,0.67,2]
uniform float mul1; slider[-2,1,2]
uniform float mul2; slider[-2,1,2]






#group Mandelbulb

// Number of fractal iterations.
uniform int Iterations;  slider[0,9,100]

// Number of color iterations.
uniform int ColorIterations;  slider[0,9,100]

// Mandelbulb exponent (8 is standard)
uniform float Power; slider[0,8,16]

// Bailout radius
uniform float Bailout; slider[0,5,30]

// Alternate is slightly different, but looks more like a Mandelbrot for Power=2
uniform bool AlternateVersion; checkbox[false]

uniform vec3 RotVector; slider[(0,0,0),(1,1,1),(1,1,1)]

uniform float RotAngle; slider[0.00,0,180]

uniform bool Julia; checkbox[false]
uniform vec3 JuliaC; slider[(-2,-2,-2),(0,0,0),(2,2,2)]

mat3 rot;
uniform float time;
void init() {
	 rot = rotationMatrix3(normalize(RotVector), RotAngle);
       float dummy = time*10.0;
}

// This is my power function, based on the standard spherical coordinates as defined here:
// http://en.wikipedia.org/wiki/Spherical_coordinate_system
//
// It seems to be similar to the one Quilez uses:
// http://www.iquilezles.org/www/articles/mandelbulb/mandelbulb.htm
//
// Notice the north and south poles are different here.
void powN1(inout vec3 z, float r, inout float dr) {
	// extract polar coordinates
	float theta = acos(z.z/r);
	float phi = atan(z.y,z.x);
	dr =  pow( r, Power-1.0)*Power*dr + 1.0;
	
	// scale and rotate the point
	float zr = pow( r,Power);
	theta = theta*Power;
	phi = phi*Power;
	
	// convert back to cartesian coordinates
	z = zr*vec3(sin(theta)*cos(phi), sin(phi)*sin(theta), cos(theta));
}

// This is a power function taken from the implementation by Enforcer:
// http://www.fractalforums.com/mandelbulb-implementation/realtime-renderingoptimisations/
//
// I cannot follow its derivation from spherical coordinates,
// but it does give a nice mandelbrot like object for Power=2
void powN2(inout vec3 z, float zr0, inout float dr) {
	float zo0 = asin( z.z/zr0 );
	float zi0 = atan( z.y,z.x );
	float zr = pow( zr0, Power-1.0 );
	float zo = zo0 * Power;
	float zi = zi0 * Power;
	dr = zr*dr*Power + 1.0;
	zr *= zr0;
	z  = zr*vec3( cos(zo)*cos(zi), cos(zo)*sin(zi), sin(zo) );
}



// Compute the distance from `pos` to the Mandelbox.
float DE(vec3 pos) {
	vec3 z=pos;
	float LimC= (1/Limiter1) + (1/Limiter2);
if (reciprocalX3bVar1)    z.x = sign(z.x) * LimC - (1/(abs(mul1*z.x)+ Limiter1)) + (1/(mul2 * z.x*z.x+ Limiter2)); 
if (reciprocalX3b)    z.x = sign(z.x) * (LimC - (1/(abs(mul1*z.x)+ Limiter1))) - (1/(mul2 * z.x*z.x+ Limiter2));
if (reciprocalY3bVar1) z.y = sign(z.y) * LimC - (1/(abs(mul1*z.y)+ Limiter1)) + (1/(mul2 * z.y*z.y+ Limiter2));
if (reciprocalY3b)     z.y = sign(z.y) * (LimC- (1/(abs(mul1*z.y)+ Limiter1))) - (1/(mul2 * z.y*z.y+ Limiter2)); 
if (reciprocalZ3bVar1)     z.z = sign(z.z) * LimC - (1/(abs(mul1*z.z)+ Limiter1)) + (1/(mul2 * z.z*z.z+ Limiter2));
if (reciprocalZ3b)     z.z = sign(z.z) * (LimC - (1/(abs(mul1*z.z)+ Limiter1))) - (1/(mul2 * z.z*z.z+ Limiter2));
	float r;
	float dr=1.0;
	int i=0;
	r=length(z);
	
	while(r<Bailout && (i<Iterations)) {
		if (AlternateVersion) {
	
		powN2(z,r,dr);
		} else {
	
			powN1(z,r,dr);
		}
		z+=(Julia ? JuliaC : pos);
		z.x=atan((sqrt(z.z))*z.y*z.y);
		r=length(z);
		z*=rot;
		if (i<ColorIterations) orbitTrap = min(orbitTrap, abs(vec4(z.x,z.y,z.z,r*r)));
		i++;
	}
//	if ((type==1) && r<Bailout) return 0.0;
	return 0.5*log(r)*r/dr;
	/*
	Use this code for some nice intersections (Power=2)
	float a =  max(0.5*log(r)*r/dr, abs(pos.y));
	float b = 1000;
	if (pos.y>0)  b = 0.5*log(r)*r/dr;
	return min(min(a, b),
		max(0.5*log(r)*r/dr, abs(pos.z)));
	*/
}

























#preset Default
AutoFocus = false
FOV = 0.62536
Eye = 2.430119,-3.541403,-4.890211
Target = 1.813815,-2.692956,-4.236517
UpLock = false
Up = -0.6555277,-0.5310999,0.0427586
AutoFocus = false
FocalPlane = 5.00155
Aperture = 0.0189781
InFocusAWidth = 0.8197518
DofCorrect = true
ApertureNbrSides = 7
ApertureRot = 238.5748
ApStarShaped = true
Gamma = 0.7792947
ToneMapping = 5
Exposure = 0.6522
Brightness = 1
Contrast = 1
Saturation = 1.460177
GaussianWeight = 1
AntiAliasScale = 1.2
Bloom = true
BloomIntensity = 0.7488584
BloomPow = 5.890208
BloomTaps = 19
BloomStrong = 1
DepthToAlpha = true
Detail = -2.761836
RefineSteps = 4
FudgeFactor = 0.2323838
MaxRaySteps = 881
MaxDistance = 100
Dither = 0
NormalBackStep = 6.103876
DetailAO = -0.0301724
coneApertureAO = 0.311649
maxIterAO = 30
FudgeAO = 0.4935438
AO_ambient = 1.016105
AO_camlight = 1.750733
AO_pointlight = 0.717873
AoCorrect = 0.5598846
Specular = 1
SpecularExp = 16.364
CamLight = 0.6352941,0.7529412,0.7803922,0.7537538
AmbiantLight = 1,1,1,0.1944444
Reflection = 0.745098,0.745098,0.745098
ReflectionsNumber = 3
SpotGlow = true
SpotLight = 0.4509804,0.4117647,0.4117647,10
LightPos = 0,-4.896755,10
LightSize = 0.0510204
LightFallOff = 0.3239227
LightGlowRad = 3.831071
LightGlowExp = 2.454819
HardShadow = 1
ShadowSoft = 0
ShadowBlur = 0
perf = true
SSS = true
sss1 = 0.2989922
sss2 = 0.1982083
BaseColor = 1,0.9803922,0.9764706
OrbitStrength = 0.0440835
X = 1,0.9803922,0.9764706,1
Y = 0.345098,0.666667,0,1
Z = 0.9921569,0.627451,0,1
R = 1,0.06666667,0.06666667,0.618705
BackgroundColor = 0.5215686,0.745098,0.8666667
GradientBackground = 0.2708638
CycleColors = true
Cycles = 0.1
EnableFloor = true
FloorNormal = 1,1,0
FloorHeight = 0.4465593
FloorColor = 0.4745098,0.2117647,0
HF_Fallof = 0.83497
HF_Const = 0
HF_Intensity = 0.012012
HF_Dir = 1,-1,-0.5751445
HF_Offset = -4.580838
HF_Color = 0.05490196,0.3490196,0.454902,1.219325
HF_Scatter = 4.022416
HF_Anisotropy = 0.1843137,0.07058824,0
HF_FogIter = 16
HF_CastShadow = true
EnCloudsDir = true NotLocked
Clouds_Dir = 0.4442793,0.1619614,-0.5156018 NotLocked
CloudScale = 10 NotLocked
CloudFlatness = -0.7077626 NotLocked
CloudTops = 0.7185629 NotLocked
CloudBase = -8.053892 NotLocked
CloudDensity = 0.9774436 NotLocked
CloudRoughness = 1.405248 NotLocked
CloudContrast = 10 NotLocked
CloudColor = 0.65,0.68,0.7 NotLocked
CloudColor2 = 0.06666667,0.1686275,0.2392157 NotLocked
SunLightColor = 0.7,0.5,0.3 NotLocked
Cloudvar1 = 1.693166 NotLocked
Cloudvar2 = 10.37975 NotLocked
CloudIter = 19 NotLocked
CloudBgMix = 1 NotLocked
reciprocalX3b = false
reciprocalX3bVar1 = false
reciprocalY3b = false
reciprocalY3bVar1 = false
reciprocalZ3b = true
reciprocalZ3bVar1 = true
Limiter1 = 0.7960057
Limiter2 = 1.001426
mul1 = 1.709497
mul2 = -0.2067039
Iterations = 20
ColorIterations = 9
Power = 16
Bailout = 1.73913
AlternateVersion = false
RotVector = 1,1,1
RotAngle = 143.5714
Julia = true
JuliaC = 0.2298851,-0.6609195,-0.0057471
#endpreset

